/*
The line for PORTA.OUT/pinMode in setup causes WEIRD problems. Somehow, the code works normally, but whenever I touch the copper bed of my board, it acts as though the button is 
pressed, as if its a conductivity sensor. There are no shorts, and this problem ONLY occurs if I touch the bed- not it I touch pins, traces, components, etc (I checked with
a wire- the wire worked too when I touched one end). Its not a short becasue I could barely touch the board with a jumper cable and the LED would still blink. After hours of 
debugging I isolated the problem to that setup line. I still have no idea what's going on here.
*/

int ledPin = 2;    //PA2, pin 3
int buttonPin = 3; //PA3, pin 4
void setup() {

PORTA.DIR = B00000100;
// if a pin is 0, it is an output, if 1, it is an input
PORTA.OUT = B00001100;
//pullup enabled in pin 4 since bit 4 in DIR A is an input, pin 3 set high since bit 3 in DIR A is an output
}

void loop()
{
 if(digRead(buttonPin))
 {
  digWrite(ledPin,HIGH);
  delay(500);
  digWrite(ledPin,LOW);
  delay(500);
 }
 if(!digRead(buttonPin))
 {
  digWrite(ledPin,HIGH);
 }
}


bool digRead(int pin){
 bool bval = ((1 << pin) & ~PORTA.IN) >> pin;
 return bval;
/*
PORTA.IN        = 00000000
~PORTA.IN.      = 11111111
1 << buttonPin  = 00001000
&               = 00001000
>> buttonPin    = 00000001
bval = 00000001 = 1
*/
}

void digWrite(int pin,bool state){
  if(state)
  { 
    PORTA.OUT = ~(1 << pin) & PORTA.OUT;
/* 
(1 << ledPin) =  00001000
~(1 << ledPin) = 11111011
PORTA.OUT =      00001100
~(1 << ledPin) & PORTA.OUT = 00001000
*/
  }
  else if (!state)
  {
    PORTA.OUT = (1 << pin) | PORTA.OUT; 
/*
PORTA.OUT     00001100     //take PORTA.OUT (all values from port A)
(1 << ledPin) 00000100 //value one shifted to location of LED pin
New PORTA.OUT 00001100 //use binary OR operator to combine values
*/
  }
}
