int ledPin = 2;    //PA2, pin 3
int buttonPin = 3; //PA3, pin 4
bool n;
void setup() {

PORTA.DIR = B00000100;
// if a pin is 0, it is an output, if 1, it is an input
PORTA.PIN3CTRL = PORTA.PIN3CTRL | PORT_PULLUPEN_bm;
//set the pullup control bit in the pin3ctrl register to 1
}

void loop()
{
 if(digRead(buttonPin))
 {
 n = !n;
   digWrite(ledPin,n);
  delay(150);
 }
}


bool digRead(int pin){    // custom function
 bool bval = ((1 << pin) & ~PORTA.IN) >> pin;
 return bval;
/*
PORTA.IN        = 00000000
~PORTA.IN.      = 11111111
1 << buttonPin  = 00001000
&               = 00001000
>> buttonPin    = 00000001
bval = 00000001 = 1
*/
}

void digWrite(int pin,bool state){
  if(state)
  {
    PORTA.OUT = ~(1 << pin) & PORTA.OUT;
/* 
(1 << ledPin) =  00001000
~(1 << ledPin) = 11111011
PORTA.OUT =      00001100
~(1 << ledPin) & PORTA.OUT = 00001000
*/
  }
  else if (!state)
  {
    PORTA.OUT = (1 << pin) | PORTA.OUT; 
/*
PORTA.OUT     00001100     //take PORTA.OUT (all values from port A)
(1 << ledPin) 00000100 //value one shifted to location of LED pin
New PORTA.OUT 00001100 //use binary OR operator to combine values
*/
  }
}
